<?php
namespace LMS\Libraries;

class Assets
{	public function __construct(\JDocument $doc)
	{		
		$this->doc = $doc;
	}	

	protected function getUri($file, $type)
	{		
		if(\JString::strpos($file, 'http') !== false){				
			return $file;
		}
		
		$file = ltrim($file, '/');
		
		$pathComponent	=  JPATH_SITE.DS.'components'.DS.'com_joomla_lms';
		$pathDestBase	= JPATH_SITE.DS.'media'.DS.'com_joomla_lms'.DS.'assets';		
		$uriPathBase	= 'media/com_joomla_lms/assets';		
		
		$parts = explode('/', $file);
					
		if(($index = array_search('assets', $parts)) !== false) {		
			if($index == 0 || $index == 2) {				
				$partsFilePathWithoutAssets = $partsFilePath = $parts;
				
				$fileName = array_pop($partsFilePath); //get file part
				unset($partsFilePathWithoutAssets[$index]); //remove assets folder from path
				$partsFilePathWithoutAssets = array_values($partsFilePathWithoutAssets);
				$fileUri = $uriPathBase.'/'.implode('/', $partsFilePathWithoutAssets);				
				$fullFileDest = $pathDestBase.DS.implode(DS, $partsFilePathWithoutAssets);
								
				//TODO uncomment block
				/*				
				if(!file_exists($fullFileDest)) 
				{
				*/					
					$partsAssetsDir = array_slice($parts, 0, $index+1);
					
					$partsBeforeAssetsDir = $partsAssetsDir;
					unset($partsBeforeAssetsDir[$index]); //remove assets folder from path				
					$partsBeforeAssetsDir = array_values($partsBeforeAssetsDir);
					
					$destDir = implode(DS, $partsBeforeAssetsDir);
					$srcDir = implode(DS, $partsAssetsDir);				
					
					$fullPathSrcDir = $pathComponent.DS.$srcDir;
					$fullPathDestDir = $pathDestBase.DS.$destDir;
					
					jimport('joomla.filesystem.folder');					
					\JFolder::copy($fullPathSrcDir.DS, $fullPathDestDir, '', true);					
				/*
				}
				*/
				
				$uri = $fileUri;
			} else { //assets folder's order is wrong it should be 1-st or 3-rd
				$uri = $uriPathBase.'/'.$file;
			}			
		} else {
			$uri = $file;
		}			
		
		return \JUri::base(true).'/'.$uri;
	}	
	
	public function addScript($file, $type = "text/javascript", $defer = false, $async = false)
	{			
		$this->doc->addScript($this->getURI($file, 'js'), $type, $defer, $async);		
	}
	
	public function addScriptDeclaration($content, $type = 'text/javascript')
	{
		$this->doc->addScriptDeclaration($content, $type);	
	}
	
	public function addStyleSheet($file, $type = 'text/css', $media = null, $attribs = array())
	{					
		$this->doc->addStyleSheet($this->getURI($file, 'css'), $type, $media, $attribs);		
	}
	
	public function addStyleDeclaration($content, $type = 'text/css')
	{
		$this->doc->addStyleDeclaration($content, $type);		
	}

	public function fetchHead() 
	{
		$renderer = $this->doc->loadRenderer('head');
		return $renderer->fetchHead($this->doc);
	}
}
?>