<?php
namespace LMS\Tools\Coursebuilder\View;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

defined('_JEXEC') or die;

class Builder extends Base\View
{
	protected $extension = 'com_joomla_lms';
	
	protected $viewName = 'Builder';	

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);		
	}

	public function step1()
	{	
		$this->widget('contentheader', array('title' => strip_tags(_JLMS_STEPS_TOOLBAR_STEP1), 'icon' => 'course'));
		
		$toolbar = $this->widget('contenttoolbar');		
		$toolbar->addSaveNextButton(array('click' => "Joomla.submitbutton('save_course');"));
		$courseId = $this->config->get('course_id');
		if ($courseId) {
			$toolbar->addCloseButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=details_course&course_id=".$this->courseId)));
		} else {
			$toolbar->addCancelButton(array('click' => "Joomla.submitbutton('cancel_course');"));
		}
		
		$this->setLayout('step1');	
		
		return parent::display();
	}
	
	public function step2()
	{	
		$this->widget('contentheader', array('title' => strip_tags(_JLMS_STEPS_TOOLBAR_STEP2), 'icon' => 'course'));
		
		$toolbar = $this->widget('contenttoolbar');
		$toolbar->addBackButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=1&course_id=".$this->courseId)));
		$toolbar->addSaveNextButton(array('click' => "Joomla.submitbutton('settings_save');"));		
		
		$this->setLayout('step2');	
		
		return parent::display();
	}
	
	public function step3()
	{	
		$this->config = ServiceLocator::get('config');		
				
		$this->widget('contentheader', array('title' => strip_tags(_JLMS_STEPS_TOOLBAR_STEP3), 'icon' => 'course'));
		
		$toolbar = $this->widget('contenttoolbar');		
		$toolbar->addBackButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=2&course_id=".$this->courseId)));
		$toolbar->addSaveNextButton(array('click' => "Joomla.submitbutton('courses.course.save');"));		
		
		$this->setLayout('step3');	
		
		return parent::display();
	}
	
	public function step4()
	{	
		$this->widget('contentheader', array('title' => strip_tags(_JLMS_STEPS_TOOLBAR_STEP4), 'icon' => 'course'));
		
		$toolbar = $this->widget('contenttoolbar');		
		$toolbar->addBackButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=3&course_id=".$this->courseId)));
		$toolbar->addSaveNextButton(array('href' => 'javascript: Joomla.submitbutton(\'coursebuilder.learningpattern.save\')'));		
		
		$this->setLayout('step4');
	
		return parent::display();
	}
	
	public function step5()
	{	
		$this->widget('contentheader', array('title' => strip_tags(_JLMS_STEPS_TOOLBAR_STEP5), 'icon' => 'course'));
		
		$toolbar = $this->widget('contenttoolbar');		
		$toolbar->addBackButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=4&course_id=".$this->courseId)));		
		$toolbar->addSaveNextButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=6&course_id=".$this->courseId)));		
		
		$this->setLayout('step4');
	
		return parent::display();
	}
	
	public function step6()
	{	
		$this->widget('contentheader', array('title' => strip_tags(_JLMS_STEPS_TOOLBAR_STEP6), 'icon' => 'course'));
		
		$toolbar = $this->widget('contenttoolbar');				
		$toolbar->addBackButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=coursebuilder.builder.show&step=5&course_id=".$this->courseId)));		
		$toolbar->addSaveButton(array('href' => \JLMSRoute::_("index.php?option=com_joomla_lms&task=details_course&course_id=".$this->courseId), 'title' => 'Finish'));
		$this->setLayout('step6');
	
		return parent::display();
	}
}