<?php
namespace LMS\Tools\Homework\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Result extends Base\Controller
{
	public function __construct($config=array())
	{
		parent::__construct($config);

		$this->registerTask('notseen', 'seen');
		$this->registerTask('upload', 'mark');
	}

	public function show()
	{
		$course_id = $this->input->get('course_id', 0);
		$id = $this->input->get('id', 0);
		$Itemid = $this->input->get('Itemid', 0);

		$modelResult = $this->getModel('Result');
		$modelResult->setState('homework.course_id', $course_id);
		$modelResult->setState('result.id', $id);
		$modelResult->setState('permissions.homework.manage', $this->acl->CheckPermissions('homework', 'manage'));
		$modelResult->setState('permissions.homework.view', $this->acl->CheckPermissions('homework', 'view'));
		$modelResult->setState('result.status', 2);

		$view = $this->getView('Result');
		if($Itemid){
			$view->Itemid = $Itemid;
		}
		$view->setModel($modelResult, true);

		$view->show();
	}

	public function mark()
	{
		$task = $this->input->get('task', 'mark');
		$jform_data = $this->input->get('jform', array(), 'array');
		$courseId = $this->input->get('course_id', 0);
		$homeworkId = $this->input->get('hw_id', 0);

		$jform_data['course_id'] = $courseId;
		$jform_data['user_id'] = $this->user->get('id');
		$jform_data['hw_id'] = $homeworkId;

//		echo '<pre>';
//		print_r($jform_data);
//		echo '</pre>';
//		die;

		$model = $this->getModel('Result');
		$model->setState('courseId', $courseId);
		$model->setState('task', $task);

		$model->mark($jform_data);

		$link = 'index.php?option=com_joomla_lms&task=homework.homeworks.show';
		$link .= '&course_id='.$courseId;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function check()
	{
		$jform_data = $this->input->get('jform', array(), 'array');
		$course_id = $jform_data['course_id'];
		$hw_id = $jform_data['hw_id'];

		$model = $this->getModel('Result');
		$model->setState('homework.course_id', $course_id);

		$model->check($jform_data);

		$link = 'index.php?option=com_joomla_lms&task=homework.results.show';
		$link .= '&course_id='.$course_id;
		$link .= '&id='.$hw_id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function delete()
	{
		$course_id = $this->input->get('course_id', 0);
		$id = $this->input->get('id', 0);
		$cid = $this->input->get('cid', array(), 'array');

		if(is_array($cid) && count($cid)){
			$model = $this->getModel('Result');

			jimport('joomla.utilities.arrayhelper');
			\JArrayHelper::toInteger($cid);

			if($this->acl->CheckPermissions('homework', 'manage')){
				$model->delete($cid);
			}
		}

		$link = 'index.php?option=com_joomla_lms&task=homework.results.show';
		$link .= '&course_id='.$course_id;
		$link .= '&id='.$id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function cancel()
	{
		$jform = $this->input->get('jform', array(), 'array');
		$course_id = isset($jform['course_id']) ? $jform['course_id'] : $this->input->get('course_id', 0);
		$hw_id = isset($jform['hw_id']) ? $jform['hw_id'] : $this->input->get('hw_id', 0);

		$link = 'index.php?option=com_joomla_lms&task=homework.results.show';
		$link .= '&course_id='.$course_id;
		$link .= '&id='.$hw_id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function seen()
	{
		$jform = $this->input->get('jform', array(), 'array');
		$course_id = $jform['course_id'];
		$id = $jform['id'];

		$model = $this->getModel('Result');
		$model->setState('result.id', $id);

		$status = 1;
		if($this->task == 'seen'){
			$status = 2;
		} else if($this->task == 'notseen'){
			$status = 1;
		}
		$model->setState('result.status', $status);

		$model->seen();

		$link = 'index.php?option=com_joomla_lms&task=homework.result.show';
		$link .= '&course_id='.$course_id;
		$link .= '&id='.$id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}

	public function upload()
	{

	}
}