<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_joomla_lms
 * 
 */

namespace LMS\Tools\Mailbox\Repositories;
 
defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Tools\Mailbox\Tables;

class Mailbox extends Base\Repository
{	
	public function __construct($options = array()) 
	{
		parent::__construct($options);
		$this->table = new Tables\Messages($this->db);
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{			
		if(!empty($filterOptions['list.filters'])) {
			$filters = $filterOptions['list.filters'];
		}		
		
		if(!empty($filterOptions['course_id'])) {
			$courseId = $filterOptions['course_id'];
		}
		
		if(!empty($filters['course_id'])) {
			$courseId = $filters['course_id'];
		}
		
		if(!empty($courseId)) {			
			$query->where('message.course_id = '.$this->db->quote($courseId));
		}
		
		if(!empty($filters['search'])) {
			$search = $filters['search'];
			$query->where('
				UPPER(message.subject) LIKE UPPER(\'%'.$search.'%\') OR UPPER(message.senderprofile.name) LIKE UPPER(\'%'.$search.'%\')
			');			
		}
		
		if(!empty($filterOptions['sender_id'])){			
			$query->where('message.sender_id = '.$filterOptions['sender_id']);
		}
		
		if(!empty($filterOptions['recipient_id'])){			
			$query->where('message.recipient.user_id = '.$filterOptions['recipient_id']);
		}		
		
		if(isset($filterOptions['is_read'])){			
			$query->where('message.recipient.is_read = '.$filterOptions['is_read']);
		}		
		
		return parent::prepareFilter($query, $filterOptions);
	}
}
