<?php
namespace LMS\Tools\Mailbox\Tables;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Messages extends Base\Table
{	
	protected $alias = 'message';
	
	function __construct(&$db)
	{
		parent::__construct( '#__lms_messages', 'id', $db );	
	}
	
	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub
		
		$this->relations = array(
			'senderprofile' => array(
				'table' => ServiceLocator::get('joomlausers_table'),
				'type' => 'INNER',
				'condition' => '{parent.sender_id} = {child.id}',
				'capacity' => self::MANY
			),
			'recipient' => array(
				'table' => new MessagesTo($this->_db),
				'type' => 'INNER',
				'condition' => '{parent.id} = {child.message_id}',
				'capacity' => self::MANY
			)
		);
	}
}
?>