<?php
defined('JPATH_PLATFORM') or die;

use LMS\Libraries;

JFormHelper::loadFieldClass('list');

class JFormFieldStaff extends JFormFieldList
{	
	protected $type = 'Staff';
	
	protected function getInput()
	{	
		$html = array();
		$attr = '';
		
		$hint = JText::_($this->hint);

		// Initialize some field attributes.
		$attr .= !empty($this->class) ? ' class="' . $this->class . '"' : '';
		$attr .= !empty($this->size) ? ' size="' . $this->size . '"' : '';		
		$attr .= $this->multiple ? ' multiple' : '';
		$attr .= !empty($this->hint) ? ' data-placeholder="' . $hint . '"' : '';
		$attr .= $this->required ? ' required aria-required="true"' : '';
		$attr .= $this->autofocus ? ' autofocus' : '';

		// To avoid user's confusion, readonly="true" should imply disabled="true".
		if ((string) $this->readonly == '1' || (string) $this->readonly == 'true' || (string) $this->disabled == '1'|| (string) $this->disabled == 'true')
		{
			$attr .= ' disabled="disabled"';
		}

		// Initialize JavaScript field attributes.
		$attr .= $this->onchange ? ' onchange="' . $this->onchange . '"' : '';
		
		Libraries\ServiceLocator::load('tool.users');
		
		$rep	= Libraries\ServiceLocator::get('staff_rep');		
		$items1 = $rep->getByFilter(array(
				'fields'=>'DISTINCT staff.profile.name, staff.profile.id'				
		));
		
		$rep	= Libraries\ServiceLocator::get('coursestaff_rep');		
		$items2 = $rep->getByFilter(array(
				'fields'=>'DISTINCT coursestaff.staff.profile.name, coursestaff.staff.profile.id'				
		));
		
		$items = array_merge($items1, $items2);
						
		$options = array();
		$options[] = '<option value="0"></option>';
		
		foreach($items AS $item) {		
			$options[] = '<option value="'.$item->id.'">'.$item->name.'</option>';			
		}			
		
		$html = '';		
		$html .= '<select id="' . $this->id . '" name="' . $this->name . '"' . $attr . '>';
		$html .= implode("\n", $options);
		$html .= '</select>';

		return $html;
	}	
}
?>