if (typeof(Jlms) === 'undefined') {
	var Jlms = {};
}

if (typeof(Jlms.Widget) === 'undefined') {
	Jlms.Widget = {};
}

Jlms.Widget.Table = function(_options){
	var $, widget = this, ext = [], storage, allSelected = false, options = {
		type: '',
		rowclickon: function(){},
		rowclickoff: function(){}
	},
	
	dom = {
		wrapper: null,
		parent: null,		
		rows: null
	},	
	highlightRowByExt = function(id) {
		dom.wrapper.find('.widget-table-row').each(function(){			
			var el = $(this);
				extId = el.data('ext-id'),
				arrExtId = extId.toString().split(',');					
					
			for(var i=0; i<arrExtId.length; i++) {
				if(arrExtId[i] == id) {
					el.addClass('info');
					return true;
				}
			}
		})
	},	
	_redraw = function() {
		var selItems = storage.getData('selected'),
			remItems = storage.getData('removed'),
			rows = dom.wrapper.find('.widget-table-row');		
		
		dom.rows.removeClass('info');		
		
		if(allSelected === true) {
			dom.rows.addClass('info');
		} else {			
			for(i=0; i<selItems.length; i++) {				
				rows.filter('[data-id='+selItems[i]+']').addClass('info');
			}
			
			if(typeof(ext) !== 'undefined') {
				if(typeof(ext) === 'object') {
					for(var i=0; i<ext.length; i++) {
						highlightRowByExt(ext[i]);
					}
				} else {
					highlightRowByExt(ext);					
				}				
			}
		}		
		
		for(i=0; i<remItems.length; i++) {
			rows.filter('[data-id='+remItems[i]+']').removeClass('info');			
		}
	},		
	init = function(_options) {		
		$ = jQuery.noConflict();	
		$.extend(options, _options);		
				
		var type = options.type, parentSelector = '#widget-table-'+type;	
		
		dom.parent = $(parentSelector);		
		dom.rows = $(dom.parent.find('.widget-table-row'));
		dom.wrapper = $(dom.parent.find('.content').eq(0));
				
		storage = new Jlms.Storage(type);			
		
		var parent = dom.parent,
			wrapper = dom.wrapper;				
		
		wrapper.on('content-loaded', function(){
			var remItems = storage.getData('removed');
			
			dom.rows = $(dom.parent.find('.widget-table-row'));
			
			if(allSelected === true  && !remItems.length) {
				dom.parent.find('.all-btn').eq(0).addClass('btn-info');					
			}				
			_redraw();
		});	
		
		firstCommonElement = function(arr1, arr2) {			
			for(var i=0; i<arr1.length; i++) {						
				for(var j=0; j<arr2.length; j++) {				
					if(arr1[i] == arr2[j]) {					
						return arr1[i];
					}
				}
			}			
			
			return false;
		};			
		
		wrapper.delegate('.pagenav', 'click', function(e) {				
			var el = $(this),
				url = el.attr('href');				
				
			wrapper.data('url', url).load(url, function(){
				wrapper.trigger('content-loaded');
			});
			
			e.preventDefault();
		});		
		
		wrapper.delegate('.widget-table-row', 'click', function(e) {			
			var el = $(this),
				id = el.data('id').toString(),
				attrExtId = el.data('ext-id');
				
			if(typeof attrExtId !== 'undefined' ) {
				extIds = attrExtId.toString().split(',');
			}				
							
			if(el.hasClass('info')) {
				if(allSelected) {					
					if(options.useExt === true) {
						storage.setData('removed', id, extIds);
					} else {
						storage.setData('removed', id);
					}						
				}else{
					if(options.useExt === true) {			
						var extId = firstCommonElement(ext, extIds);
						if(ext.length && extId !== false) {						
							storage.setData('removed', id, extId);
						} else {							
							storage.removeData('selected', id, extIds[0]);
						}
					} else {
						storage.removeData('selected', id);
					}		
				}				
				options.rowclickoff(id);
			} else {					
				if(allSelected) {
					if(options.useExt === true) {
						storage.removeData('removed',id, extIds);
					} else {
						storage.removeData('removed', id);
					}
				}else{
					if(options.useExt === true) {
						var extId = firstCommonElement(ext, extIds);
						if(ext.length && extId !== false) {
							storage.removeData('removed', id, extId);							
						} else {							
							storage.setData('selected', id, extIds[0]);
						}							
					} else {
						storage.setData('selected', id);
					}
				}
				options.rowclickon(id);
			}				
			_redraw();						
		})					
	};
	
	if(typeof(_options.type) !== 'undefined' && typeof(this.instance) !== 'undefined' && typeof(this.instance[_options.type]) !== 'undefined') {		
		return this.instance[_options.type];
	}
	
	this.instance = {};		
	this.instance[_options.type] = this;	
	
	init(_options);
	
	this.getStorage = function(){
		return storage;
	}
	
	this.allSelected = function(value){		
		if(typeof value !== 'undefined') {
			allSelected = value;
		}		
		return allSelected;
	}
	
	this.redraw =function(_ext){
		if(!_ext) {
			_ext = [];
		}
		ext = _ext;
		_redraw();
	}
		
	this.wrapper = dom.wrapper;
	
	this.dom = dom.parent;
	
	return this;
}